#include "HumanDetection.h"
HumanDetection* HumanDetection::instance = nullptr;

HumanDetection::HumanDetection(){
    
}
HumanDetection::~HumanDetection(){
}
int HumanDetection::findHuManCar(const cv::Mat &source,int res,TCV_HumanDetector *detector){
    TCV_CameraStream *stream = TCV_CreateCameraStream();
    TCV_CameraStreamSetData(stream, source.data, source.cols, source.rows);
    TCV_CameraStreamSetRotationMode(stream, TCV_CAMERA_ROTATION_0);
    TCV_CameraStreamSetStreamFormat(stream, TCV_STREAM_BGR);
    //0是人 1是车

    // 执行一帧目标检测
    TCV_HumanDetectorProcessFrame(detector, stream);
    int num=-1;
    if(res==0x00 || res==0x02){
        num= TCV_HumanDetectorGetNumOfHuman(detector);
        if (num > 0 && res==0x02) {
            // 创建一个接收检测结果的对象数组
            TCV_ObjectLocation result[num];
            // 提取行人检测结果
            TCV_HumanDetectorGetHumanLocation(detector, result, num);
            int num_uniforms = 0;
            //工服
            for (int i = 0; i < num; ++i) {
                if (result[i].uniform == 0) {
                    ++num_uniforms;
                }
            }
            num=num_uniforms;
        }
        qDebug() << (res == 0 ? "Number of people detected:" : "Number of people with uniform == 0 detected:") << num;

    }else if (res==0x01) {
        num=TCV_HumanDetectorGetNumOfCar(detector);
        qDebug() << "Number of cars detected:" << num;

    }else {
        qDebug() << "参数错误";

    }
    TCV_ReleaseCameraStream(stream);
    return  num;
}

